import PyIPSDK
import PyIPSDK.IPSDKIPLAdvancedMorphology as advmorpho
import PyIPSDK.IPSDKIPLArithmetic as arithm
import PyIPSDK.IPSDKIPLBinarization as bin
import PyIPSDK.IPSDKIPLGlobalMeasure as glbmsr
import PyIPSDK.IPSDKIPLLogical as logic
import PyIPSDK.IPSDKIPLUtility as util
from UsefullWidgets import Measure

def My_function( inImg1, direction, reverse ):

	print(direction, reverse)

	if(direction=="X"):
		if(reverse==False):
			img2 = arithm.formula3dImg("if ((x==0)&&(I1==1), true, false)", InOptImg3d1=inImg1)
			img4 = arithm.formula3dImg("if ((x==Sx-1)&&(I1==1), true, false)", InOptImg3d1=inImg1)
		else:
			img2= arithm.formula3dImg("if ((x==Sx-1)&&(I1==1), true, false)", InOptImg3d1=inImg1)
			img4 = arithm.formula3dImg("if ((x==0)&&(I1==1), true, false)", InOptImg3d1=inImg1)
		size = inImg1.getSizeX()

	elif(direction=="Y"):
		if(reverse==False):
			img2 = arithm.formula3dImg("if ((y==0)&&(I1==1), true, false)", InOptImg3d1=inImg1)
			img4 = arithm.formula3dImg("if ((y==Sy-1)&&(I1==1), true, false)", InOptImg3d1=inImg1)
		else:
			img2 = arithm.formula3dImg("if ((y==Sy-1)&&(I1==1), true, false)", InOptImg3d1=inImg1)
			img4 = arithm.formula3dImg("if ((y==0)&&(I1==1), true, false)", InOptImg3d1=inImg1)
		size = inImg1.getSizeY()

	if(direction=="Z"):
		if(reverse==False):
			img2 = arithm.formula3dImg("if ((z==0)&&(I1==1), true, false)", InOptImg3d1=inImg1)
			img4 = arithm.formula3dImg("if ((z==Sz-1)&&(I1==1), true, false)", InOptImg3d1=inImg1)
		else:
			img2= arithm.formula3dImg("if ((z==Sz-1)&&(I1==1), true, false)", InOptImg3d1=inImg1)
			img4 = arithm.formula3dImg("if ((z==0)&&(I1==1), true, false)", InOptImg3d1=inImg1)
		size = inImg1.getSizeZ()

	img3 = util.convertImg(inImg1,PyIPSDK.eIBT_Real32)
	_ = advmorpho.seededDistanceMap3dImg(inImg1, img2,1,1,1,PyIPSDK.eN3T_26Connexity,img3)

	maskRef = bin.lightThresholdImg(img3,1)
	maskRef = logic.bitwiseOrImgImg(maskRef,img2)
	img3 = arithm.addScalarImg(img3,1)
	img3 = logic.maskImg(img3,maskRef)
	
	img5 = logic.bitwiseAndImgImg(inImg1,img4)

	img6 = bin.lightThresholdImg(img3,(size-1))
	img6 = logic.bitwiseAndImgImg(img5,img6)
	
	output = glbmsr.statsMaskMsr3d(img3,img6)
	
	maskStats = glbmsr.statsMsr3d(img6)

	if maskStats.max == 0:
		minVal = 0
	else:
		minVal = output.min

	tortuosity = minVal/size

	measureTortuosity = Measure()
	measureTortuosity.subType = "Table"
	measureTortuosity.value = [["Length","Tortuosity"],[minVal,tortuosity]]

	img3.lut = "Magma"
	img3.background = False

	return measureTortuosity, img3











































